## hyphy 2.3.14+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(HyPhy)
cmake_policy(VERSION 3.0.0)
cmake_policy(SET CMP0026 NEW)

set(CMAKE_CONFIGURATION_TYPES Release)

#-------------------------------------------------------------------------------
# OPTIONS
#-------------------------------------------------------------------------------

option(NOAVX OFF)
option(NOSSE3 OFF)

#-------------------------------------------------------------------------------
# SSE MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_SSE3)
  include(CheckCXXSourceRuns)
  set(CMAKE_REQUIRED_FLAGS)

  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      set(CMAKE_REQUIRED_FLAGS "-msse3")
  endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")

  check_cxx_source_runs("
      #include <pmmintrin.h>
      int main ()
      {
          __m128d a, b;
          double vals[2] = {0};
          a = _mm_loadu_pd (vals);
          b = _mm_hadd_pd (a,a);
          _mm_storeu_pd (vals, b);
          return (0);
      }"
      HAVE_SSE3_EXTENSIONS)
endmacro(PCL_CHECK_FOR_SSE3)

#-------------------------------------------------------------------------------
# SSE MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_AVX)
  include(CheckCXXSourceRuns)
  set(CMAKE_REQUIRED_FLAGS)

  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      set(CMAKE_REQUIRED_FLAGS "-march=corei7-avx -mtune=corei7-avx")
  endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")

  check_cxx_source_runs("
      #include <immintrin.h>
      int main ()
      {
          __m256d a, b;
          double vals[4] = {0.};
          a = _mm256_loadu_pd (vals);
          b = _mm256_hadd_pd (a,a);
          _mm256_storeu_pd (vals, b);
          return (0);
      }"
      HAVE_AVX_EXTENSIONS)
endmacro(PCL_CHECK_FOR_AVX)


#-------------------------------------------------------------------------------
# set the CMAKE_MODULE_PATH so we can import OpenCL
#-------------------------------------------------------------------------------
set(CMAKE_MODULE_PATH cmake)
set(HYPHY_VERSION 2.1)


#-------------------------------------------------------------------------------
# setup the files we'll be using
#-------------------------------------------------------------------------------
file(GLOB SRC_CORE src/core/*.cpp)
file(GLOB SRC_GTESTS tests/gtests/*.cpp)
file(GLOB SRC_NEW src/new/*.cpp)

set(SRC_LINK src/lib/link/THyPhy.cpp)
set(SRC_SQLITE3 contrib/SQLite-3.8.2/sqlite3.c)
set(SRC_UNIXMAIN src/mains/unix.cpp)
set(SRC_UTILS src/utils/hyphyunixutils.cpp)

set(SRC_COMMON ${SRC_CORE} ${SRC_NEW} ${SRC_SQLITE3} ${SRC_UTILS})


#-------------------------------------------------------------------------------
# make it fast, scotty
#-------------------------------------------------------------------------------

set(DEFAULT_WARNING_FLAGS "-w")
set(DEFAULT_DEBUG_WARNING_FLAGS "-Wall -Wno-int-to-pointer-cast -Wno-conversion-null -Wno-sign-compare -Wno-maybe-uninitialized")


if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    execute_process(
        COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
        OUTPUT_VARIABLE GCC_VERSION
    )

    if (${GCC_VERSION} VERSION_LESS 4.9)
        message(FATAL_ERROR "Require at least gcc-4.9")
    endif()

    if(${GCC_VERSION} VERSION_LESS 6.0)
      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -std=gnu++14")
    else(${GCC_VERSION} VERSION_LESS 6.0)
      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3")
    endif(${GCC_VERSION} VERSION_LESS 6.0)

    if(NOAVX)
        set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-avx")
        if(NOSSE3)
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-sse3")
        else(NOSSE)
            PCL_CHECK_FOR_SSE3()
            if(${HAVE_SSE3_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
            endif(${HAVE_SSE3_EXTENSIONS})
        endif(NOSSE3)
    else(NOAVX)
       PCL_CHECK_FOR_AVX()
       if(${HAVE_AVX_EXTENSIONS})
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=corei7-avx -mtune=corei7-avx")
            add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
        else(${HAVE_AVX_EXTENSIONS})
            PCL_CHECK_FOR_SSE3()
            if(${HAVE_SSE3_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
            endif(${HAVE_SSE3_EXTENSIONS})
        endif(${HAVE_AVX_EXTENSIONS})
    endif(NOAVX)


    set(DEFAULT_LINK_FLAGS "${DEFAULT_COMPILE_FLAGS}")
endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3")
    PCL_CHECK_FOR_AVX()
    if(${HAVE_AVX_EXTENSIONS})
        set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=corei7-avx -mtune=corei7-avx ")
        add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
    else(${HAVE_AVX_EXTENSIONS})
        PCL_CHECK_FOR_SSE3()
        if(${HAVE_SSE3_EXTENSIONS})
            add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3")
        endif(${HAVE_SSE3_EXTENSIONS})
    endif (${HAVE_AVX_EXTENSIONS})

    set_property(
     SOURCE ${SRC_CORE}
     APPEND_STRING PROPERTY  COMPILE_FLAGS " -std=c++14 "
    )
endif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}")
MESSAGE ("Set compiler flags to ${DEFAULT_COMPILE_FLAGS}")

if(NOT DEFINED DEFAULT_COMPILE_FLAGS)
    set(DEFAULT_COMPILE_FLAGS "")
endif(NOT DEFINED DEFAULT_COMPILE_FLAGS)

if(NOT DEFINED DEFAULT_LINK_FLAGS)
    set(DEFAULT_LINK_FLAGS "")
endif(NOT DEFINED DEFAULT_LINK_FLAGS)

if(NOT DEFINED DEFAULT_WARNING_FLAGS)
    set(DEFAULT_WARNING_FLAGS "")
endif(NOT DEFINED DEFAULT_WARNING_FLAGS)

include (CheckLibraryExists)

CHECK_LIBRARY_EXISTS( "libamdlibm.so" "amd_log" "" HAS_AMD_LIBM)
if(HAS_AMD_LIBM)
    set(DEFAULT_LINK_FLAGS "${DEFAULT_LINK_FLAGS} -lamdlibm")
    add_definitions(-D__USEAMDLOG__)
endif(HAS_AMD_LIBM)


#-------------------------------------------------------------------------------
# OpenMP support
#-------------------------------------------------------------------------------
find_package(OpenMP)

if(NOT ${OPENMP_FOUND})
    set(OpenMP_CXX_FLAGS "")
endif(NOT ${OPENMP_FOUND})

#-------------------------------------------------------------------------------
# default installation prefix
#-------------------------------------------------------------------------------
if(NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "Installation prefix")
endif()
if(NOT DEFINED INSTALL_PREFIX)
    set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE INTERNAL "Installation prefix" FORCE)
endif()
if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    set(DEFAULT_LIBRARIES pthread)
else(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    set(DEFAULT_LIBRARIES dl pthread)
endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")

#-------------------------------------------------------------------------------
# LIBCurl support
#-------------------------------------------------------------------------------
find_package(CURL)
if(${CURL_FOUND} AND NOT APPLE)
    if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
        set(DEFAULT_LIBRARIES pthread crypto curl ssl)
    else(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
        set(DEFAULT_LIBRARIES dl pthread crypto curl ssl)
    endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    add_definitions (-D__HYPHYCURL__)
endif(${CURL_FOUND} AND NOT APPLE)

#-------------------------------------------------------------------------------
# gtest dependency
#-------------------------------------------------------------------------------
add_subdirectory(contrib/gtest-1.7.0)
set_property(
    TARGET gtest gtest_main
    PROPERTY EXCLUDE_FROM_ALL true
)


#-------------------------------------------------------------------------------
# uninstall target
#-------------------------------------------------------------------------------
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY
)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)




#-------------------------------------------------------------------------------
# setup some source properties so that we don't spam stdout
#-------------------------------------------------------------------------------
set_property(
    SOURCE ${SRC_CORE}
    APPEND_STRING PROPERTY  COMPILE_FLAGS "${DEFAULT_WARNING_FLAGS}"
)

set_property(
    SOURCE ${SRC_SQLITE3}
    APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-int-to-pointer-cast -Wno-pointer-to-int-cast -std=c99"
)

set_property(
    SOURCE src/core/calcnode2.cpp
    APPEND_STRING PROPERTY COMPILE_FLAGS " -fstrict-aliasing -funroll-loops"
)

set_property(
  SOURCE ${SRC_CORE}
  APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-int-to-pointer-cast"
)

#-------------------------------------------------------------------------------
# shared compilation definitions and header includes
#-------------------------------------------------------------------------------
add_definitions(-D_SLKP_LFENGINE_REWRITE_ -D__AFYP_REWRITE_BGM__)

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    add_definitions(-D__HYPHY_64__)
endif(CMAKE_SIZEOF_VOID_P EQUAL 8)

include_directories(
    src/core/include
    src/lib/Link src/new/include
    contrib/SQLite-3.8.2 # SQLite
    contrib/gtest-1.7.0/include
    tests/gtests
)


#-------------------------------------------------------------------------------
# shared hyphy hbl stdlib target
#-------------------------------------------------------------------------------
install(DIRECTORY res/ DESTINATION lib/hyphy)

#-------------------------------------------------------------------------------
# HYPHYMP target
#-------------------------------------------------------------------------------
add_executable(
    HYPHYMP
    ${SRC_COMMON} ${SRC_UNIXMAIN}
)

target_link_libraries(HYPHYMP ${DEFAULT_LIBRARIES})

add_custom_target(MP DEPENDS HYPHYMP)

install(
    TARGETS HYPHYMP
    RUNTIME DESTINATION bin
    OPTIONAL
)

#-------------------------------------------------------------------------------
# hyphy OpenCL target
#-------------------------------------------------------------------------------
find_package(OpenCL)
if(${OPENCL_FOUND})

    add_executable(
        HYPHYOCL
        EXCLUDE_FROM_ALL
        ${SRC_COMMON} ${SRC_UNIXMAIN} ${CMAKE_CURRENT_BINARY_DIR}/src/ocl/opencl_kernels.h
    )

    include_directories(${OPENCL_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/src/ocl)
    target_link_libraries(HYPHYOCL ${DEFAULT_LIBRARIES} ${OPENCL_LIBRARIES})

    add_custom_target(OCL DEPENDS HYPHYOCL)
    set_property(
        TARGET HYPHYOCL
        APPEND PROPERTY COMPILE_DEFINITIONS __MP__ __MP2__ __UNIX__ _HY_GPU_EXAMPLE_CALCULATOR MDSOCL
    )
    set_target_properties(
        HYPHYOCL
        PROPERTIES
        COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} ${DEFAULT_WARNING_FLAGS}"
        LINK_FLAGS "${DEFAULT_LINK_FLAGS}"
    )
    add_executable(
        cl2hdr
        EXCLUDE_FROM_ALL
        contrib/cl2hdr.c
    )
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/src/ocl/opencl_kernels.h
        COMMAND cl2hdr ${CMAKE_CURRENT_SOURCE_DIR}/src/ocl/opencl_kernels.cl ${CMAKE_CURRENT_BINARY_DIR}/src/ocl/opencl_kernels.h
        DEPENDS cl2hdr ${CMAKE_CURRENT_SOURCE_DIR}/src/ocl/opencl_kernels.cl
    )
endif(${OPENCL_FOUND})


#-------------------------------------------------------------------------------
# hyphy mpi target

=== debian/changelog ===
hyphy (2.3.14+dfsg-2) unstable; urgency=medium

  [ Saira Hussain ]
  * Team upload.
  * Add unit test description file
  * Add the SimpleAnalyses suite for testing
  * Add control file for AUTOPKGTESTS

  [ Andreas Tille ]
  * Standards-Version: 4.3.1

 -- Saira Hussain <saira.0213@zoho.com>  Fri, 05 Jul 2019 13:45:06 +0000

hyphy (2.3.14+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper 11
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Wed, 26 Sep 2018 16:55:30 +0200

=== debian/control ===
Source: hyphy
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake (>= 3.0),
               mpi-default-dev,
               libcurl4-gnutls-dev | libcurl4-dev,
               libssl-dev,
               libsqlite3-dev
Standards-Version: 4.3.1
Vcs-Browser: https://salsa.debian.org/med-team/hyphy
Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
Homepage: http://hyphy.org/

Package: hyphy-pt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         hyphy-common
Description: Hypothesis testing using Phylogenies (pthreads version)
 HyPhy is an open-source software package for the analysis of genetic
 sequences using techniques in phylogenetics, molecular evolution, and
 machine learning. It features a complete graphical user interface (GUI)
 and a rich scripting language for limitless customization of analyses.
 Additionally, HyPhy features support for parallel computing environments
 (via message passing interface) and it can be compiled as a shared
 library and called from other programming environments such as Python or
 R.  Continued development of HyPhy is currently supported in part by an
 NIGMS R01 award 1R01GM093939.
 .
 This package provides an executable using pthreads to do multiprocessing.

Package: hyphy-mpi
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         hyphy-common
Description: Hypothesis testing using Phylogenies (MPI version)
 HyPhy is an open-source software package for the analysis of genetic
 sequences using techniques in phylogenetics, molecular evolution, and
 machine learning. It features a complete graphical user interface (GUI)
 and a rich scripting language for limitless customization of analyses.
 Additionally, HyPhy features support for parallel computing environments
 (via message passing interface) and it can be compiled as a shared
 library and called from other programming environments such as Python or
 R.  Continued development of HyPhy is currently supported in part by an
 NIGMS R01 award 1R01GM093939.
 .
 This package provides an executable using MPI to do multiprocessing.

Package: hyphy-common
Architecture: all
Depends: ${misc:Depends}
Suggests: hyphygui | hyphy-mpi | hyphy-pt
Description: Hypothesis testing using Phylogenies (common files)
 HyPhy is an open-source software package for the analysis of genetic
 sequences using techniques in phylogenetics, molecular evolution, and
 machine learning. It features a complete graphical user interface (GUI)
 and a rich scripting language for limitless customization of analyses.
 Additionally, HyPhy features support for parallel computing environments
 (via message passing interface) and it can be compiled as a shared
 library and called from other programming environments such as Python or
 R.  Continued development of HyPhy is currently supported in part by an
 NIGMS R01 award 1R01GM093939.
 .
 This package provides files that are common to all binary versions.

## hyphy 2.5.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(HyPhy)
cmake_policy(VERSION 3.0.0)
#cmake_policy(SET CMP0026 OLD)
#cmake_policy(SET CMP0004 OLD)


set(CMAKE_CONFIGURATION_TYPES Release)

#-------------------------------------------------------------------------------
# OPTIONS
#-------------------------------------------------------------------------------

option(NOAVX OFF)
option(NOSSE3 OFF)

#-------------------------------------------------------------------------------
# SSE MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_SSE3)
  include(CheckCXXSourceRuns)
  set(CMAKE_REQUIRED_FLAGS)

  #if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
      set(CMAKE_REQUIRED_FLAGS "-msse3")
  #endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)

  check_cxx_source_runs("
      #include <pmmintrin.h>
      #include <stdio.h>

      int main ()
      {
          __m128d a, b;
          double vals[2] = {0};
          a = _mm_loadu_pd (vals);
          b = _mm_hadd_pd (a,a);
          _mm_storeu_pd (vals, b);
          printf (\"%g\", vals[0]);
          return (0);
      }"
      HAVE_SSE3_EXTENSIONS)
endmacro(PCL_CHECK_FOR_SSE3)

#-------------------------------------------------------------------------------
# SSE MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_AVX)
  include(CheckCXXSourceRuns)
  set(CMAKE_REQUIRED_FLAGS)

  #if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
      set(CMAKE_REQUIRED_FLAGS "-mavx")
  #endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)

  check_cxx_source_runs("
      #include <immintrin.h>
      #include <stdio.h>

      int main ()
      {
          __m256d a, b;
          double vals[4] = {0.};
          a = _mm256_loadu_pd (vals);
          b = _mm256_hadd_pd (a,a);
          _mm256_storeu_pd (vals, b);
          printf (\"%g\", vals[0]);
          return (0);
      }"
      HAVE_AVX_EXTENSIONS)
endmacro(PCL_CHECK_FOR_AVX)

#-------------------------------------------------------------------------------
# FMA3 MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_FMA3)
    include(CheckCXXSourceRuns)
    set(CMAKE_REQUIRED_FLAGS)

    #if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
        set(CMAKE_REQUIRED_FLAGS "-mavx -mfma ")
    #endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)

    check_cxx_source_runs("
    #include <immintrin.h>
    #include <stdio.h>

    int main ()
    {
        __m256d a, b, c;
        double vals[4] = {2.};
        a = _mm256_loadu_pd (vals);
        b = _mm256_loadu_pd (vals);
        c = _mm256_loadu_pd (vals);
        a = _mm256_fmadd_pd      (a, b, c);
        _mm256_storeu_pd (vals, a);
        printf (\"%g\", vals[0]);
        return 0;
    }"
    HAVE_FMA3)
endmacro(PCL_CHECK_FOR_FMA3)


#-------------------------------------------------------------------------------
# set the CMAKE_MODULE_PATH so we can import OpenCL
#-------------------------------------------------------------------------------
set(CMAKE_MODULE_PATH cmake)
set(HYPHY_VERSION 2.1)

#-------------------------------------------------------------------------------
# setup the files we'll be using
#-------------------------------------------------------------------------------
file(GLOB SRC_CORE src/core/*.cpp)
file(GLOB SRC_GTESTS tests/gtests/*.cpp)
file(GLOB SRC_NEW src/new/*.cpp)
file(GLOB SRC_CONTRIB src/contrib/*.cpp)

set(SRC_LINK src/lib/link/THyPhy.cpp)
set(SRC_SQLITE3 contrib/SQLite-3.8.2/sqlite3.c)
set(SRC_UNIXMAIN src/mains/unix.cpp)
set(SRC_UTILS src/utils/hyphyunixutils.cpp)


set(SRC_COMMON ${SRC_CORE} ${SRC_NEW} ${SRC_SQLITE3} ${SRC_UTILS} ${SRC_CONTRIB})
set_source_files_properties(${SRC_CORE} ${SRC_NEW} {SRC_UTILS} PROPERTIES COMPILE_FLAGS "-Weffc++ -Wextra -Wall")

#-------------------------------------------------------------------------------
# make it fast, scotty
#-------------------------------------------------------------------------------

set(DEFAULT_WARNING_FLAGS " -w  ")
set(DEFAULT_DEBUG_WARNING_FLAGS "-Wall -Wno-int-to-pointer-cast -Wno-conversion-null -Wno-sign-compare -Wno-maybe-uninitialized")



if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    execute_process(
        COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
        OUTPUT_VARIABLE GCC_VERSION
    )

    if (${GCC_VERSION} VERSION_LESS 4.9)
        message(FATAL_ERROR "Require at least gcc-4.9")
    endif()

    if(${GCC_VERSION} VERSION_LESS 6.0)
      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -std=gnu++14")
    else(${GCC_VERSION} VERSION_LESS 6.0)
      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -std=c++14")
    endif(${GCC_VERSION} VERSION_LESS 6.0)

    if(NOAVX)
        set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-avx")
        if(NOSSE3)
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-sse3")
        else(NOSSE)
            PCL_CHECK_FOR_SSE3()
            if(${HAVE_SSE3_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
            endif(${HAVE_SSE3_EXTENSIONS})
        endif(NOSSE3)
    else(NOAVX)
       PCL_CHECK_FOR_AVX()
       if(${HAVE_AVX_EXTENSIONS})
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=native -mtune=native -mavx")
            add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
            PCL_CHECK_FOR_FMA3()
            if (${HAVE_FMA3})
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  -mfma")
                add_definitions (-D_SLKP_USE_FMA3_INTRINSICS)
            endif (${HAVE_FMA3})
        else(${HAVE_AVX_EXTENSIONS})
            PCL_CHECK_FOR_SSE3()
            if(${HAVE_SSE3_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
            endif(${HAVE_SSE3_EXTENSIONS})
        endif(${HAVE_AVX_EXTENSIONS})
    endif(NOAVX)


    set(DEFAULT_LINK_FLAGS "${DEFAULT_COMPILE_FLAGS}")
endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3")
    PCL_CHECK_FOR_AVX()

    if(${HAVE_AVX_EXTENSIONS} AND NOT ${NOAVX})
        set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=native -mtune=native -mavx")
        add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
        PCL_CHECK_FOR_FMA3()
        if (${HAVE_FMA3})
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mfma")
            add_definitions (-D_SLKP_USE_FMA3_INTRINSICS)
        endif (${HAVE_FMA3})
    else(${HAVE_AVX_EXTENSIONS} AND NOT ${NOAVX})
        PCL_CHECK_FOR_SSE3()
        if(${HAVE_SSE3_EXTENSIONS})
            add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
        endif(${HAVE_SSE3_EXTENSIONS})
    endif (${HAVE_AVX_EXTENSIONS})

    set_property(
     SOURCE ${SRC_CORE} ${SRC_NEW} ${SRC_UTILS} ${SRC_UNIXMAIN}
     APPEND_STRING PROPERTY  COMPILE_FLAGS " -std=c++14 "
    )
endif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  ")
MESSAGE ("Set compiler flags to ${DEFAULT_COMPILE_FLAGS}")

if(NOT DEFINED DEFAULT_COMPILE_FLAGS)
    set(DEFAULT_COMPILE_FLAGS "")
endif(NOT DEFINED DEFAULT_COMPILE_FLAGS)

if(NOT DEFINED DEFAULT_LINK_FLAGS)
    set(DEFAULT_LINK_FLAGS "")
endif(NOT DEFINED DEFAULT_LINK_FLAGS)

set(DEFAULT_LINK_FLAGS "${DEFAULT_LINK_FLAGS}  ")

if(NOT DEFINED DEFAULT_WARNING_FLAGS)
    set(DEFAULT_WARNING_FLAGS "")
endif(NOT DEFINED DEFAULT_WARNING_FLAGS)


#-------------------------------------------------------------------------------
# OpenMP support
#-------------------------------------------------------------------------------
find_package(OpenMP)

#-------------------------------------------------------------------------------
# default installation prefix
#-------------------------------------------------------------------------------
if(NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "Installation prefix")
endif()
if(NOT DEFINED INSTALL_PREFIX)
    set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE INTERNAL "Installation prefix" FORCE)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	set(DEFAULT_LIBRARIES )
else(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    set(DEFAULT_LIBRARIES dl)
endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")

#-------------------------------------------------------------------------------
# LIBCurl support
#-------------------------------------------------------------------------------
find_package(CURL)
if(${CURL_FOUND} AND NOT APPLE)
    if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
        set(DEFAULT_LIBRARIES crypto curl ssl)
    else(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
        set(DEFAULT_LIBRARIES dl crypto curl ssl)
    endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    add_definitions (-D__HYPHYCURL__)
endif(${CURL_FOUND} AND NOT APPLE)

#-------------------------------------------------------------------------------
# gtest dependency
#-------------------------------------------------------------------------------
add_subdirectory(contrib/gtest-1.7.0)
set_property(
    TARGET gtest gtest_main
    PROPERTY EXCLUDE_FROM_ALL true
)


#-------------------------------------------------------------------------------
# uninstall target
#-------------------------------------------------------------------------------
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY
)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

find_program(NODE npm)
if(NOT NODE)
    message("Node not installed; API documentation will not be generated")
else(NOT NODE)
    add_custom_target(
        docs
        rm -rf ./docs && npm install -g documentation@4 && documentation build --polyglot -f md ./res/TemplateBatchFiles/libv3/**/*.bf -o ./docs.md
    )
endif(NOT NODE)


#-------------------------------------------------------------------------------
# setup some source properties so that we don't spam stdout
#-------------------------------------------------------------------------------
set_property(
    SOURCE ${SRC_CORE}
    APPEND_STRING PROPERTY  COMPILE_FLAGS "${DEFAULT_WARNING_FLAGS}"
)

set_property(
    SOURCE ${SRC_SQLITE3}
    APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-int-to-pointer-cast -Wno-pointer-to-int-cast -std=c99"
)

set_property(
    SOURCE src/core/calcnode2.cpp
    APPEND_STRING PROPERTY COMPILE_FLAGS " -fstrict-aliasing -funroll-loops"
)

set_property(
  SOURCE ${SRC_CORE}
  APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-int-to-pointer-cast"
)

#-------------------------------------------------------------------------------
# shared compilation definitions and header includes
#-------------------------------------------------------------------------------
add_definitions(-D_SLKP_LFENGINE_REWRITE_ -D__AFYP_REWRITE_BGM__)


include_directories(
    src/core/include
    src/contrib
    src/lib/Link src/new/include
    contrib/SQLite-3.8.2 # SQLite
    contrib/gtest-1.7.0/include
    tests/gtests
)


#-------------------------------------------------------------------------------
# shared hyphy hbl stdlib target
#-------------------------------------------------------------------------------
install(DIRECTORY res/ DESTINATION lib/hyphy)

#-------------------------------------------------------------------------------
# HYPHYMP target
#-------------------------------------------------------------------------------
add_executable(
    hyphy

=== debian/changelog ===
hyphy (2.5.1+dfsg-3) unstable; urgency=medium

  * Versioned Depends: hyphy-common (= ${source:Version})
    Closes: #948093

 -- Andreas Tille <tille@debian.org>  Tue, 07 Jan 2020 21:23:52 +0100

hyphy (2.5.1+dfsg-2) unstable; urgency=medium

  * Fix installation of NEWS.Debian to enable arch all only builds
  * Make autopkgtest more verbose

 -- Andreas Tille <tille@debian.org>  Sat, 04 Jan 2020 21:21:58 +0100

hyphy (2.5.1+dfsg-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Add pkg-config to Build-Depends as FindMPI.cmake will need it for cross
    compilation. (Closes: #943311)

  [ Andreas Tille ]
  * New upstream version
  * debhelper-compat 12
  * Secure URI in copyright format
  * Remove trailing whitespace in debian/changelog
  * New upstream version
  * Standards-Version: 4.4.1
  * Use secure URI in Homepage field.
  * Remove patches msse_option_only_if_available.patch that are missing
    from debian/patches/series.
  * Skip GTEST target for the moment since this is currently in flux
    see https://github.com/veg/hyphy/issues/1058
  * No need to rename executables any more since upstream is doing this now
  * Autopkgtest exists since last release - so close bug
    Closes: #909707

 -- Andreas Tille <tille@debian.org>  Fri, 06 Dec 2019 22:47:47 +0100

=== debian/control ===
--- 
+++ 
@@ -3,22 +3,23 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
-               cmake (>= 3.0),
+Build-Depends: debhelper-compat (= 12),
+               cmake,
                mpi-default-dev,
                libcurl4-gnutls-dev | libcurl4-dev,
                libssl-dev,
-               libsqlite3-dev
-Standards-Version: 4.3.1
+               libsqlite3-dev,
+               pkg-config
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/hyphy
 Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
-Homepage: http://hyphy.org/
+Homepage: https://hyphy.org/
 
 Package: hyphy-pt
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         hyphy-common
+         hyphy-common (= ${source:Version})
 Description: Hypothesis testing using Phylogenies (pthreads version)
  HyPhy is an open-source software package for the analysis of genetic
  sequences using techniques in phylogenetics, molecular evolution, and
@@ -36,7 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         hyphy-common
+         hyphy-common (= ${source:Version})
 Description: Hypothesis testing using Phylogenies (MPI version)
  HyPhy is an open-source software package for the analysis of genetic
  sequences using techniques in phylogenetics, molecular evolution, and

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

include /usr/share/dpkg/default.mk

export PYBUILD_NAME=$(DEB_SOURCE)
PYVERS = $(shell pyversions -r)
PY3VERS = $(shell py3versions -r)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_PREFIX=/usr

override_dh_auto_build:
	# no idea about the purpose of the dynamic library - executables are not simply linked against it
	dh_auto_build -- MP MPI
	# GTEST
	echo "Skip GTEST target for the moment - see https://github.com/veg/hyphy/issues/1058"
	# LIB

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	find obj-* -name HYPHYGTEST -exec \{\} \;
endif

override_dh_installdocs-arch:
	dh_installdocs -a
	for news in debian/NEWS.Debian.* ; do \
	    pkg=`echo $${news} | sed 's/.*NEWS.Debian.//'` ; \
	    cp -a $${news} debian/$${pkg}/usr/share/doc/$${pkg}/NEWS.Debian ; \
	done

override_dh_installdocs-indep:
	dh_installdocs -i

## hyphy 2.5.20+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #cmake_policy(SET CMP0026 OLD)
 #cmake_policy(SET CMP0004 OLD)
 
+enable_testing()
 
 set(CMAKE_CONFIGURATION_TYPES Release)
 
@@ -114,7 +115,6 @@
 # setup the files we'll be using
 #-------------------------------------------------------------------------------
 file(GLOB SRC_CORE src/core/*.cpp)
-file(GLOB SRC_GTESTS tests/gtests/*.cpp)
 file(GLOB SRC_NEW src/new/*.cpp)
 file(GLOB SRC_CONTRIB src/contrib/*.cpp)
 
@@ -137,7 +137,7 @@
 
 
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
-    execute_process(
+     execute_process(
         COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
         OUTPUT_VARIABLE GCC_VERSION
     )
@@ -147,16 +147,18 @@
     endif()
 
     if(${GCC_VERSION} VERSION_LESS 6.0)
-      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -std=gnu++14")
+      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -std=gnu++14 ")
     else(${GCC_VERSION} VERSION_LESS 6.0)
       set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -std=c++14")
     endif(${GCC_VERSION} VERSION_LESS 6.0)
+
+    #set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  -fopt-info")
 
     if(NOAVX)
         set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-avx")
         if(NOSSE3)
             set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-sse3")
-        else(NOSSE)
+        else(NOSSE3)
             PCL_CHECK_FOR_SSE3()
             if(${HAVE_SSE3_EXTENSIONS})
                 add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
@@ -187,24 +189,36 @@
 endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
 
 if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-    set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3")
-    PCL_CHECK_FOR_AVX()
-
-    if(${HAVE_AVX_EXTENSIONS} AND NOT ${NOAVX})
-        set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=native -mtune=native -mavx")
-        add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
-        PCL_CHECK_FOR_FMA3()
-        if (${HAVE_FMA3})
-            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mfma")
-            add_definitions (-D_SLKP_USE_FMA3_INTRINSICS)
-        endif (${HAVE_FMA3})
-    else(${HAVE_AVX_EXTENSIONS} AND NOT ${NOAVX})
-        PCL_CHECK_FOR_SSE3()
-        if(${HAVE_SSE3_EXTENSIONS})
-            add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
-            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
-        endif(${HAVE_SSE3_EXTENSIONS})
-    endif (${HAVE_AVX_EXTENSIONS})
+    #set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3  -fsave-optimization-record=yaml ")
+    set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 ")
+    if(NOAVX)
+        if(NOSSE3)
+            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-sse3")
+        else(NOSSE3)
+            PCL_CHECK_FOR_SSE3()
+            if(${HAVE_SSE3_EXTENSIONS})
+                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
+                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
+            endif(${HAVE_SSE3_EXTENSIONS})
+        endif(NOSSE3)
+    else(NOAVX)
+        PCL_CHECK_FOR_AVX()
+        if(${HAVE_AVX_EXTENSIONS})
+            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=native -mtune=native -mavx")
+            add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
+            PCL_CHECK_FOR_FMA3()
+            if (${HAVE_FMA3})
+                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mfma")
+                add_definitions (-D_SLKP_USE_FMA3_INTRINSICS)
+            endif (${HAVE_FMA3})
+        else(${HAVE_AVX_EXTENSIONS})
+            PCL_CHECK_FOR_SSE3()
+            if(${HAVE_SSE3_EXTENSIONS})
+                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
+                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse3 ")
+            endif(${HAVE_SSE3_EXTENSIONS})
+        endif (${HAVE_AVX_EXTENSIONS})
+    endif(NOAVX)
 
     set_property(
      SOURCE ${SRC_CORE} ${SRC_NEW} ${SRC_UTILS} ${SRC_UNIXMAIN}
@@ -212,7 +226,8 @@
     )
 endif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
 
-set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  ")
+#set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  -fopt-info -fopt-info-vec-missed")
+set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}")
 MESSAGE ("Set compiler flags to ${DEFAULT_COMPILE_FLAGS}")
 
 if(NOT DEFINED DEFAULT_COMPILE_FLAGS)
@@ -264,14 +279,6 @@
     add_definitions (-D__HYPHYCURL__)
 endif(${CURL_FOUND} AND NOT APPLE)
 
-#-------------------------------------------------------------------------------
-# gtest dependency
-#-------------------------------------------------------------------------------
-add_subdirectory(contrib/gtest-1.7.0)
-set_property(
-    TARGET gtest gtest_main
-    PROPERTY EXCLUDE_FROM_ALL true
-)
 
 
 #-------------------------------------------------------------------------------
@@ -331,18 +338,8 @@
     src/contrib
     src/lib/Link src/new/include
     contrib/SQLite-3.8.2 # SQLite
-    contrib/gtest-1.7.0/include
-    tests/gtests
 )
 
 
 #-------------------------------------------------------------------------------
 # shared hyphy hbl stdlib target
-#-------------------------------------------------------------------------------
-install(DIRECTORY res/ DESTINATION lib/hyphy)
-
-#-------------------------------------------------------------------------------
-# HYPHYMP target
-#-------------------------------------------------------------------------------
-add_executable(
-    hyphy

=== debian/changelog ===
hyphy (2.5.20+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 22 Oct 2020 20:14:59 +0530

hyphy (2.5.19+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Refresh patches
  * Wrap up manual pages for hyphy-pt and hyphy-mpi

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Sat, 10 Oct 2020 15:27:47 +0200

hyphy (2.5.18+dfsg-1) unstable; urgency=medium

  [ Étienne Mollier ]
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Build with NOAVX and NOSSE3 cmake switches.  (Closes: #961382)
  * GTEST removed in favor of script run_unit_tests.sh:
      - updated d/copyright to remove gtest and include src/contrib;
      - removed note about gtest in d/rules;
      - removed lintian-overrides related to gtest.
  * Refreshed patches:
      - removed drop_profiling_option.patch;
      - removed patches related to gtest;
      - refreshed use_debian_sqlite.patch;
      - added patch to fix compilation issues with NOAVX and NOSSE3;
      - added patch to allow compilation on non-x86 CPU architectures.
  * Refreshed d/hyphy-common.install.

  [ Andreas Tille ]
  * d/rules: Remove some settings made for the former Python package

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Mon, 28 Sep 2020 21:33:54 +0200

## hyphy 2.5.21+dfsg

=== debian/changelog ===
hyphy (2.5.21+dfsg-2) unstable; urgency=medium

  * Team Upload.
  * Remove failing tests on 32-bit archs

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 31 Oct 2020 23:42:17 +0530

hyphy (2.5.21+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 31 Oct 2020 19:16:55 +0530

## hyphy 2.5.22+dfsg

=== debian/changelog ===
hyphy (2.5.22+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 17 Nov 2020 18:54:31 +0530

## hyphy 2.5.23+dfsg

=== debian/changelog ===
hyphy (2.5.23+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Wed, 18 Nov 2020 20:07:16 +0000

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: hyphy
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <etienne.mollier@mailoo.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                mpi-default-dev,
                libcurl4-gnutls-dev | libcurl4-dev,
                libssl-dev,
                libsqlite3-dev,
                pkg-config
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/hyphy
 Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
 Homepage: https://hyphy.org/
+Rules-Requires-Root: no
 
 Package: hyphy-pt
 Architecture: any

## hyphy 2.5.24+dfsg

=== debian/changelog ===
hyphy (2.5.24+dfsg-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Fix reference to the build directory
    Closes: #977992

 -- Andreas Tille <tille@debian.org>  Thu, 24 Dec 2020 07:11:25 +0100

hyphy (2.5.24+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

 -- Nilesh Patra <npatra974@gmail.com>  Mon, 21 Dec 2020 13:35:37 +0530

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/veg/hyphy/releases .*/archive/v*(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## hyphy 2.5.25+dfsg

=== debian/changelog ===
hyphy (2.5.25+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 10 Jan 2021 11:25:52 +0530

## hyphy 2.5.26+dfsg

=== debian/changelog ===
hyphy (2.5.26+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.26+dfsg
  * Add createmanpages script to
    manage manpages for future versions
  * Update hyphy manpage

 -- Nilesh Patra <npatra974@gmail.com>  Mon, 18 Jan 2021 13:57:49 +0000

## hyphy 2.5.27+dfsg

=== debian/changelog ===
hyphy (2.5.27+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Fix arch independent build issue which cause the amd64 autopkgtests to
    fail.
  * On amd64, run the build-time tests the SIMD varients that are supported by
    the build-time CPU.

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 31 Jan 2021 11:05:20 +0100

hyphy (2.5.27+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix arch independent build.
  * debian/control: mark hyphy-common as Multi-Arch: foreign

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 30 Jan 2021 12:52:56 +0100

hyphy (2.5.27+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Refresh patches.
  * debian/rules: build avx and sse3 version for amd64

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 30 Jan 2021 10:03:12 +0100

hyphy (2.5.27+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 26 Jan 2021 16:47:41 +0530

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: hyphy
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
-           Étienne Mollier <etienne.mollier@mailoo.org>
+           Étienne Mollier <etienne.mollier@mailoo.org>,
+           Nilesh Patra <npatra974@gmail.com>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -11,7 +12,7 @@
                libssl-dev,
                libsqlite3-dev,
                pkg-config
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/hyphy
 Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
 Homepage: https://hyphy.org/
@@ -55,6 +56,7 @@
 
 Package: hyphy-common
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: hyphygui | hyphy-mpi | hyphy-pt
 Description: Hypothesis testing using Phylogenies (common files)

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

include /usr/share/dpkg/default.mk

# a few ISO-8859-1 files needing conversion to UTF-8
ISOFILES  = res/TemplateBatchFiles/PARRIS.bf
ISOFILES += res/TemplateBatchFiles/TemplateModels/MEC.mdl
ISOFILES += res/TemplateBatchFiles/TemplateModels/models.lst

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean

override_dh_auto_configure:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_configure -- -DINSTALL_PREFIX=/usr -DNOAVX=ON -DNOSSE3=ON
	dh_auto_configure --builddirectory obj-avx -- -DINSTALL_PREFIX=/usr -DNOAVX=OFF -DNOSSE3=OFF
	dh_auto_configure --builddirectory obj-sse3 -- -DINSTALL_PREFIX=/usr -DNOAVX=ON -DNOSSE3=OFF
else
	dh_auto_configure -- -DINSTALL_PREFIX=/usr -DNOAVX=ON -DNOSSE3=ON
endif

override_dh_auto_build:
	# convert a few ISO-8859-1 files to address national-encoding
	set -e \
	; for file in $(ISOFILES) \
	; do    iconv -f ISO-8859-1 -t UTF-8 < $${file} > "$${file}.new" \
	;	mv "$${file}.new" "$${file}" \
	; done
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_build -- MP MPI
	dh_auto_build --builddirectory obj-avx -- MP MPI
	dh_auto_build --builddirectory obj-sse3 -- MP MPI
else
	dh_auto_build -- MP MPI
endif

override_dh_install-arch:
	dh_install -a
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin
	mkdir -p debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin
	cp obj-avx/HYPHYMPI debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin/HYPHYMPI-avx
	cp obj-sse3/HYPHYMPI debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin/HYPHYMPI-sse3
	cp obj-avx/hyphy debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin/hyphy-avx
	cp obj-sse3/hyphy debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin/hyphy-sse3
	mv debian/hyphy-mpi/usr/bin/HYPHYMPI debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin/
	mv debian/hyphy-pt/usr/bin/hyphy debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin/
	cd $(CURDIR)/debian/hyphy-mpi/usr/bin && \
		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch HYPHYMPI
	cd $(CURDIR)/debian/hyphy-pt/usr/bin && \
		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch hyphy
endif

override_dh_install-indep:
	dh_install -i
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install -phyphy-common debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/bin
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (amd64,$(DEB_HOST_ARCH))
	set -e ; for SIMD in avx sse3 ; do \
		if lscpu | grep -q $${SIMD} ; then \
			find "obj-$${SIMD}/" \
			-not -path "*/CMakeFiles/*" \
			-type f,l \
			-executable \
			-exec cp -v '{}' . \; && \
			./run_unit_tests.sh ; \
		fi ; \
	done
endif
	find "obj-$(DEB_HOST_GNU_TYPE)/" \
		-not -path "*/CMakeFiles/*" \
		-type f,l \
		-executable \
		-exec cp -v '{}' . \;
	./run_unit_tests.sh
endif

override_dh_installdocs-arch:
	dh_installdocs -a
	for news in debian/NEWS.Debian.* ; do \
	    pkg=`echo $${news} | sed 's/.*NEWS.Debian.//'` ; \
	    cp -a $${news} debian/$${pkg}/usr/share/doc/$${pkg}/NEWS.Debian ; \
	done

override_dh_installdocs-indep:
	dh_installdocs -i
